﻿using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using cz.zcu.PreSti.DirectX;
using System.Windows.Forms;
using System.Drawing;
using cz.zcu.PreSti.XNADirectX;

namespace cz.zcu.PreSti.Components
{
    public class InputKeyboardComponent : RunnableComponent
    {
        #region Fields
        private bool enabled = false;
        private XNADirectXPresentation xnaPresentation = null;
        private KeyEventHandler keyPressHandler;
        private int value;
        #endregion

        #region properties

        #endregion

        public InputKeyboardComponent(IPresentation p)
            : base(p, 2, 1, 0, 2)
        {
            if (p is XNADirectXPresentation) xnaPresentation = (XNADirectXPresentation)p;
            Priority = 10;
            Finished += new EventHandler(onFinished);
            keyPressHandler = new KeyEventHandler(keyPressed);
        }

        public override void update() { }

        public override void trigIn(int n)
        {
            if (xnaPresentation != null)
            {
                if (n == 0 && !enabled)
                {
                    xnaPresentation.WindowCont.KeyDown += keyPressHandler;
                    enabled = true;
                }

                if (n == 1 && enabled)
                {
                    xnaPresentation.WindowCont.KeyDown -= keyPressHandler;
                    enabled = true;
                }
            }
        }

        private void onFinished(object sender, EventArgs e) { }

        private void keyPressed(object sender, KeyEventArgs e)
        {
            value = e.KeyValue;
            trigOut(0);
        }

        public override object getValueFromGetter(int getterN)
        {
            switch (getterN)
            {
                case 0:
                    return value;
                case 1:
                    return char.ConvertFromUtf32(value).ToString();
                default:
                    return base.getValueFromGetter(getterN);
            }
        }
    }
}
